/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.threeten.bp.LocalDate;

import java.util.Objects;

/**
 * Information related to the medical service claim circonstance.
 */
@ApiModel(description = "Information related to the medical service claim circonstance.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class MedicalService {
  @SerializedName("medical_service_description")
  private String medicalServiceDescription = null;

  @SerializedName("symptoms_started_at")
  private LocalDate symptomsStartedAt = null;

  @SerializedName("assistance_started_at")
  private LocalDate assistanceStartedAt = null;

  @SerializedName("assistance_finished_at")
  private LocalDate assistanceFinishedAt = null;

  @SerializedName("diagnosis")
  private String diagnosis = null;

  @SerializedName("medical_treatment_received")
  private String medicalTreatmentReceived = null;

  @SerializedName("medical_center_name")
  private String medicalCenterName = null;

  public MedicalService medicalServiceDescription(String medicalServiceDescription) {
    this.medicalServiceDescription = medicalServiceDescription;
    return this;
  }

   /**
   * From the point of view of the affected person, what happened during the medical service.
   * @return medicalServiceDescription
  **/
  @ApiModelProperty(value = "From the point of view of the affected person, what happened during the medical service.")
  public String getMedicalServiceDescription() {
    return medicalServiceDescription;
  }

  public void setMedicalServiceDescription(String medicalServiceDescription) {
    this.medicalServiceDescription = medicalServiceDescription;
  }

  public MedicalService symptomsStartedAt(LocalDate symptomsStartedAt) {
    this.symptomsStartedAt = symptomsStartedAt;
    return this;
  }

   /**
   * Date and time when the patient began to have symptoms. UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mm:ssZ).
   * @return symptomsStartedAt
  **/
  @ApiModelProperty(value = "Date and time when the patient began to have symptoms. UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mm:ssZ).")
  public LocalDate getSymptomsStartedAt() {
    return symptomsStartedAt;
  }

  public void setSymptomsStartedAt(LocalDate symptomsStartedAt) {
    this.symptomsStartedAt = symptomsStartedAt;
  }

  public MedicalService assistanceStartedAt(LocalDate assistanceStartedAt) {
    this.assistanceStartedAt = assistanceStartedAt;
    return this;
  }

   /**
   * Date and time when the patient started to receive medical assistance. UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mm:ssZ).
   * @return assistanceStartedAt
  **/
  @ApiModelProperty(required = true, value = "Date and time when the patient started to receive medical assistance. UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mm:ssZ).")
  public LocalDate getAssistanceStartedAt() {
    return assistanceStartedAt;
  }

  public void setAssistanceStartedAt(LocalDate assistanceStartedAt) {
    this.assistanceStartedAt = assistanceStartedAt;
  }

  public MedicalService assistanceFinishedAt(LocalDate assistanceFinishedAt) {
    this.assistanceFinishedAt = assistanceFinishedAt;
    return this;
  }

   /**
   * Date and time when the patient finished to receive medical assistance. UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mm:ssZ).
   * @return assistanceFinishedAt
  **/
  @ApiModelProperty(required = true, value = "Date and time when the patient finished to receive medical assistance. UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mm:ssZ).")
  public LocalDate getAssistanceFinishedAt() {
    return assistanceFinishedAt;
  }

  public void setAssistanceFinishedAt(LocalDate assistanceFinishedAt) {
    this.assistanceFinishedAt = assistanceFinishedAt;
  }

  public MedicalService diagnosis(String diagnosis) {
    this.diagnosis = diagnosis;
    return this;
  }

   /**
   * Medical diagnosis of the affected person.
   * @return diagnosis
  **/
  @ApiModelProperty(required = true, value = "Medical diagnosis of the affected person.")
  public String getDiagnosis() {
    return diagnosis;
  }

  public void setDiagnosis(String diagnosis) {
    this.diagnosis = diagnosis;
  }

  public MedicalService medicalTreatmentReceived(String medicalTreatmentReceived) {
    this.medicalTreatmentReceived = medicalTreatmentReceived;
    return this;
  }

   /**
   * Medical treament received by the affected person.
   * @return medicalTreatmentReceived
  **/
  @ApiModelProperty(required = true, value = "Medical treament received by the affected person.")
  public String getMedicalTreatmentReceived() {
    return medicalTreatmentReceived;
  }

  public void setMedicalTreatmentReceived(String medicalTreatmentReceived) {
    this.medicalTreatmentReceived = medicalTreatmentReceived;
  }

  public MedicalService medicalCenterName(String medicalCenterName) {
    this.medicalCenterName = medicalCenterName;
    return this;
  }

   /**
   * Medical Center that received the affected person.
   * @return medicalCenterName
  **/
  @ApiModelProperty(required = true, value = "Medical Center that received the affected person.")
  public String getMedicalCenterName() {
    return medicalCenterName;
  }

  public void setMedicalCenterName(String medicalCenterName) {
    this.medicalCenterName = medicalCenterName;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    MedicalService medicalService = (MedicalService) o;
    return Objects.equals(this.medicalServiceDescription, medicalService.medicalServiceDescription) &&
        Objects.equals(this.symptomsStartedAt, medicalService.symptomsStartedAt) &&
        Objects.equals(this.assistanceStartedAt, medicalService.assistanceStartedAt) &&
        Objects.equals(this.assistanceFinishedAt, medicalService.assistanceFinishedAt) &&
        Objects.equals(this.diagnosis, medicalService.diagnosis) &&
        Objects.equals(this.medicalTreatmentReceived, medicalService.medicalTreatmentReceived) &&
        Objects.equals(this.medicalCenterName, medicalService.medicalCenterName);
  }

  @Override
  public int hashCode() {
    return Objects.hash(medicalServiceDescription, symptomsStartedAt, assistanceStartedAt, assistanceFinishedAt, diagnosis, medicalTreatmentReceived, medicalCenterName);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class MedicalService {\n");
    
    sb.append("    medicalServiceDescription: ").append(toIndentedString(medicalServiceDescription)).append("\n");
    sb.append("    symptomsStartedAt: ").append(toIndentedString(symptomsStartedAt)).append("\n");
    sb.append("    assistanceStartedAt: ").append(toIndentedString(assistanceStartedAt)).append("\n");
    sb.append("    assistanceFinishedAt: ").append(toIndentedString(assistanceFinishedAt)).append("\n");
    sb.append("    diagnosis: ").append(toIndentedString(diagnosis)).append("\n");
    sb.append("    medicalTreatmentReceived: ").append(toIndentedString(medicalTreatmentReceived)).append("\n");
    sb.append("    medicalCenterName: ").append(toIndentedString(medicalCenterName)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

